dofile_once("data/scripts/lib/utilities.lua")

local entity_id = GetUpdatedEntityID()
local owner = EntityGetParent(entity_id)

local projectiles = EntityGetInRadiusWithTag(x, y, 150, "projectile")

for i, projectile in ipairs(projectiles) do
  -- Make sure we only attach one of our own HomingComponents per projectile
  local var_store = get_variable_storage_component(projectile, "matran_homing_projectile")
  if not var_store then
    EntityAddComponent2(projectile, "HomingComponent", {
      predefined_target = owner,
      detect_distance = 150,
      homing_targeting_coeff = 20,
      homing_velocity_multiplier = 0.95,
      max_turn_rate = 3.5,
    })
    EntityAddComponent2(projectile, "VariableStorageComponent", {
      name = "matran_homing_projectile"
    })
  end
end
