local entity_id = GetUpdatedEntityID()
local owner = EntityGetParent(entity_id)

local damage_model_component = EntityGetFirstComponentIncludingDisabled(owner, "DamageModelComponent")
if damage_model_component then
  -- Store old values so we can restore them
  local blood_material = ComponentGetValue2(damage_model_component, "blood_material")
  local blood_spray_material = ComponentGetValue2(damage_model_component, "blood_spray_material")
  local blood_multiplier = ComponentGetValue2(damage_model_component, "blood_multiplier")
  EntityAddComponent(entity_id, "VariableStorageComponent", {
    name = "matran_bleed_gold_old_values_blood_material",
    value_string = blood_material,
  })
  EntityAddComponent(entity_id, "VariableStorageComponent", {
    name = "matran_bleed_gold_old_values_blood_spray_material",
    value_string = blood_spray_material,
  })
  EntityAddComponent(entity_id, "VariableStorageComponent", {
    name = "matran_bleed_gold_old_values_blood_multiplier",
    value_float = blood_multiplier,
  })
  ComponentSetValue2(damage_model_component, "blood_material", "gold")
  ComponentSetValue2(damage_model_component, "blood_spray_material", "gold")
  ComponentSetValue2(damage_model_component, "blood_multiplier", 0.25)
end
