function modify_value(projectile_component, prop, func)
  local value = ComponentObjectGetValue2(projectile_component, "config_explosion", prop)
  value = func(value)
  ComponentObjectSetValue2(projectile_component, "config_explosion", prop, value)
end

function shot(projectile_entity)
  local projectile_component = EntityGetFirstComponentIncludingDisabled(projectile_entity, "ProjectileComponent")
  if projectile_component then
    local bonus = 3
    local add_explosion_sprite = false
    modify_value(projectile_component, "knockback_force", function(v) return v * bonus end)
    modify_value(projectile_component, "explosion_radius", function(v)
      local result = v * bonus
      if result > 20 then
        add_explosion_sprite = true
      end
      return result
    end)
    modify_value(projectile_component, "max_durability_to_destroy", function(v) return v + bonus end)
    modify_value(projectile_component, "ray_energy", function(v) return v * bonus end)
    modify_value(projectile_component, "cell_explosion_power", function(v) return v * bonus end)
    modify_value(projectile_component, "cell_explosion_radius_min", function(v) return v * bonus end)
    modify_value(projectile_component, "cell_explosion_radius_max", function(v) return v * bonus end)
    modify_value(projectile_component, "cell_explosion_velocity_min", function(v) return v * bonus end)
    modify_value(projectile_component, "cell_explosion_damage_required", function(v) return v * bonus end)
    modify_value(projectile_component, "cell_explosion_probability", function(v) return v * bonus end)
    modify_value(projectile_component, "cell_explosion_power_ragdoll_coeff", function(v) return v * bonus end)
    -- if add_explosion_sprite then
    --   modify_value(projectile_component, "load_this_entity", function(v)
    --     return v ~= "" and v or "data/entities/particles/particle_explosion/main_gunpowder_large.xml,data/entities/misc/loose_ground.xml"
    --   end)
    -- end
  end
end
