dofile_once("mods/material_randomizer/files/utils.lua")

local entity_id = GetUpdatedEntityID()
local x, y = EntityGetTransform(entity_id)
local owner = EntityGetParent(entity_id)

if not EntityHasTag(owner, "player_unit") then return end

local noodle_off = get_component_by_props(owner, "LuaComponent", { script_source_file = "mods/material_randomizer/files/effects/noodle_arm/off.lua" })
-- If this component exists it's a re-apply
if noodle_off then
  EntityRemoveComponent(owner, noodle_off)
else
  local arm_entity = EntityGetWithName("arm_r")
  local sprite_component = EntityGetFirstComponentIncludingDisabled(arm_entity, "SpriteComponent")
  local hotspot_component = EntityGetFirstComponent(owner, "HotspotComponent", "right_arm_root")
  EntitySetComponentIsEnabled(arm_entity, sprite_component, false)
  ComponentSetValue2(hotspot_component, "sprite_hotspot_name", "")
  local noodle_arm = EntityLoad("mods/material_randomizer/files/effects/noodle_arm/entity.xml")

  -- Set the verlet positions to the arm position
  local verlet_physics_component = EntityGetFirstComponent(noodle_arm, "VerletPhysicsComponent")
  local positions = ComponentGetValue2(verlet_physics_component, "positions")
  local positions_prev = ComponentGetValue2(verlet_physics_component, "positions_prev")
  for i=1,#positions,2 do
    positions[i] = x
    positions[i+1] = y
    positions_prev[i] = x
    positions_prev[i+1] = y
  end
  ComponentSetValue2(verlet_physics_component, "positions", positions)
  ComponentSetValue2(verlet_physics_component, "positions_prev", positions_prev)

  EntityAddChild(owner, noodle_arm)
end
