dofile_once("data/scripts/gun/gun_actions.lua")

local entity_id = GetUpdatedEntityID()
local x, y = EntityGetTransform(entity_id)
local owner = EntityGetParent(entity_id)
SetRandomSeed(x, y + GameGetFrameNum())

max_uses = {}

function get_max_uses(action_id)
  for i, action in ipairs(actions) do
    if not max_uses[action.id] then
      max_uses[action.id] = action.max_uses or -1
    end
    if action_id == action.id then
      return max_uses[action_id]
    end
  end
end

local deck_needs_update = false

local children = EntityGetAllChildren(owner) or {}
for i, child in ipairs(children) do
  if EntityGetName(child) == "inventory_quick" then
    local items = EntityGetAllChildren(child) or {}
    for i, item in ipairs(items) do
      -- Check if it's a wand
      if EntityGetFirstComponentIncludingDisabled(item, "ManaReloaderComponent") then
        -- Get all it's spells
        local spell_entities = EntityGetAllChildren(item) or {}
        for i, spell_entity in ipairs(spell_entities) do
          local item_action_component = EntityGetFirstComponentIncludingDisabled(spell_entity, "ItemActionComponent")
          local item_component = EntityGetFirstComponentIncludingDisabled(spell_entity, "ItemComponent")
          local action_id = ComponentGetValue2(item_action_component, "action_id")
          local uses_remaining = ComponentGetValue2(item_component, "uses_remaining")
          local max_uses = get_max_uses(action_id)
          -- Higher chance for spells with more max_uses, lower chance for lower max_uses
          local should_increase = Random(1, 50) <= max_uses
          if should_increase and uses_remaining >= 0 and uses_remaining < max_uses then
            ComponentSetValue2(item_component, "uses_remaining", uses_remaining + 1)
            deck_needs_update = true
          end
        end
      end
    end
  end
end

if deck_needs_update then
  -- Force re-equipping the held wand to make the gun system update it
  local inventory2_comp = EntityGetFirstComponent(owner, "Inventory2Component")
  if inventory2_comp then
    ComponentSetValue(inventory2_comp, "mActualActiveItem", "0")
  end
end
