-- Loads a material from an xml file and converts it to a xml2lua tree table.
function load_material(filepath)
  local handler
  if not EntityCreateNew then
    local xml2lua = dofile("C:/Program Files (x86)/Steam/steamapps/common/Noita/mods/material_randomizer/lib/xml2lua.lua")
    local f = io.open("C:/Program Files (x86)/Steam/steamapps/common/Noita/" .. filepath, "r")
    handler = xml2lua.parse(f:read("*all"))
    f:close()
  else
    local xml2lua = dofile("mods/material_randomizer/lib/xml2lua.lua")
    handler = xml2lua.parse(ModTextFileGetContent(filepath))
  end
  return handler.root.CellData
end

local materials_to_add = {
  load_material("mods/material_randomizer/files/materials/super_dense.xml"), -- Super dense through-most-things-seeping liquid
  load_material("mods/material_randomizer/files/materials/dummy.xml"), -- Dummy material so we can replace CellDataChild and specifiy a parent without actually inheriting anything
  load_material("mods/material_randomizer/files/materials/explodium.xml"),
}

local materials_to_replace = {
  ground = {
    load_material("mods/material_randomizer/files/materials/cheese.xml"),
    load_material("mods/material_randomizer/files/materials/uranium.xml"),
    load_material("mods/material_randomizer/files/materials/barely_visible.xml"),
  },
  sand = {
    load_material("mods/material_randomizer/files/materials/sugar.xml"),
  },
  liquid = {
    load_material("mods/material_randomizer/files/materials/milk.xml"),
  }
}

return { materials_to_add, materials_to_replace }
