function create_random_material_name()
  local prefixes = { "Ako", "Un", "An", "Po", "Ka", "Thy", "Xan", "Pan", "Ra", "Kon", "E",
    "En", "Qua", "Zha", "Qar", "Ypto", "Cry", "Cal", "Ino", "Bis", "Etha", "Try", "Bo", "Ypso",
    "Hypo", "Etto", "Jun", "Rhyo", "Tip", "Dol", "Gol", "Iso", "Ya" }
  local mid = { "thal", "thun", "dyn", "kal", "phyn", "rhy", "zhu", "xyl", "phan",
    "cla", "khol", "gha", "bi", "tri", "hexa", "pto", "philo", "san", "xeno", "pho",
    "tera", "vani", "tho", "pa", "la", "di", "do", "ma", "khy" }
  local postfixes = { "dium", "nium", "ym", "one", "sal", "um", "om", "ten", "zon",
    "rz", "than", "san", "mium", "nium", "muth", "rin", "orium", "phean", "ter", "dyn",
    "mite", "sin", "nut", "roth" }

  return prefixes[math.random(1, #prefixes)]
      .. mid[math.random(1, #mid)]
      .. postfixes[math.random(1, #postfixes)]
end

function create_random_material_name_short()
  local prefixes = { "Tho", "Kha", "Pho", "Win", "Fil", "Sha", "Xan", "Pan", "Ra", "Kon", "Ely",
    "Uri", "Radu", "Xyno", "Ge", "Yp", "Op", "Fu", "Da", "De", "Di", "Try", "Ha", "Ho",
    "Neo", "Exu", "Ita", "Xylo", "Tith", "Dol", "Gol", "Illo", "Ya" }
  local postfixes = { "rium", "nium", "mit", "dun", "sal", "um", "om", "tuphyt", "zont",
    "rz", "than", "san", "vult", "xeter", "muth", "rin", "shiit", "velum", "tuch", "roph",
    "mite", "nyte", "nut", "roth" }

  return prefixes[math.random(1, #prefixes)] .. postfixes[math.random(1, #postfixes)]
end

function create_random_material_names(aprox_amount)
  local random_material_names = {}
  local random_material_names_keys = {}
  for i=1,aprox_amount do
    local name
    if math.random(1, 100) <= 25 then
      name = create_random_material_name_short()
    else
      name = create_random_material_name()
    end
    if not random_material_names_keys[name] then
      random_material_names_keys[name] = true
      table.insert(random_material_names, name)
    end
  end
  return random_material_names
end
