-- h = [0, 360], s = [0.0, 1.0],  v = [0.0, 1.0]
function hsv2rgb(h, s, v)
  local C = v * s
  local X = C * (1 - math.abs(h / 60 % 2 - 1))
  local m = v - C
  local r, g, b
  if h >= 0 and h < 60 then
    r, g, b = C, X, 0
  elseif h >= 60 and h < 120 then
    r, g, b = X, C, 0
  elseif h >= 120 and h < 180 then
    r, g, b = 0, C, X
  elseif h >= 180 and h < 240 then
    r, g, b = 0, X, C
  elseif h >= 240 and h < 300 then
    r, g, b = X, 0, C
  elseif h >= 300 and h < 360 then
    r, g, b = C, 0, X
  end
  return math.ceil((r + m) * 255), math.ceil((g + m) * 255), math.ceil((b + m) * 255)
end

function argb2hex(a, r, g, b)
  return string.format("%.2X", a) .. string.format("%.2X", r) .. string.format("%.2X", g) .. string.format("%.2X", b)
end

-- Returns a random floating point number between 0.0 and min if only 1 argument is passed, otherwise between min and max
function randf(min, max)
  if max == nil then
    return math.random() * min
  end
  if min > max then
    min, max = max, min
  end
  return math.random() * (max - min) + min
end

-- Integer version of randf
function rand(min, max)
  return math.floor(randf(min, max and max+1 or nil))
end

function random_from_table(t)
  return t[rand(1, #t)]
end

function get_setting(setting_id)
  return ModSettingGet("material_randomizer." .. setting_id)
end
