ModLuaFileAppend("data/scripts/status_effects/status_list.lua", "mods/material_randomizer/files/status_list_append.lua")
ModLuaFileAppend("data/scripts/gun/gun.lua", "mods/material_randomizer/files/gun_append.lua")
ModLuaFileAppend("data/scripts/gun/gun_extra_modifiers.lua", "mods/material_randomizer/files/gun_extra_modifiers_append.lua")
ModRegisterAudioEventMappings("mods/material_randomizer/audio/GUIDs.txt")
dofile_once("mods/material_randomizer/files/utilities.lua")

local function string_split(inputstr, sep)
  sep = sep or "%s"
  local t = {}
  for str in string.gmatch(inputstr, "([^"..sep.."]+)") do
    table.insert(t, str)
  end
  return t
end

function set_materials_that_damage(entity_id, materials)
  local damage_model_component = EntityGetFirstComponentIncludingDisabled(entity_id, "DamageModelComponent")
  if damage_model_component ~= nil then
    local materials_that_damage = string_split(ComponentGetValue2(damage_model_component, "materials_that_damage"), ",")
    for i, material in ipairs(materials_that_damage) do
      EntitySetDamageFromMaterial(entity_id, material, 0)
    end
    for material, damage in pairs(materials) do
      EntitySetDamageFromMaterial(entity_id, material, damage)
    end
  end
end

function OnPlayerSpawned(player)
  if get_setting("randomize_material_damages") then
    -- materials_that_damage is a global set by ranzomizer.lua in OnModInit
    set_materials_that_damage(player, materials_that_damage)
  end
end

function OnModInit()
  if SessionNumbersGetValue("is_biome_map_initialized") == "0" then
    ModSettingRemove("material_randomizer.current_seed")
  end
  dofile("mods/material_randomizer/files/randomizer.lua")
end
